import sys
from assignments import assign_value
import gzip
from general import one_dim_arrays_to_variables

def options_to_dict(user_inputs):
    options = {};
    current_var = -9999;
    options[current_var] = [];
    for i in range(len(user_inputs)):
        if user_inputs[i][0] == '-' and not user_inputs[i][1].isdigit():
            current_var = user_inputs[i];
            options[current_var] = [];
        else:
            options[current_var].append(user_inputs[i])

    del options[-9999]

    return options
            

def get_initial_value(user_inputs,flag,type,narg,default):
    
    value = get_value_from_flag(user_inputs,flag,type,narg,default);
    
    check_value_initialized(value,flag,default);

    return value;

def get_value_from_flag(user_inputs,flag,type,narg,default):
    #Set Variables
    is_filled = 0;
    if narg > 1:
        value = range(narg);
    else:
        value = -9999;
    i = 1;
    #Iterate through options to find flag
    while i < len(user_inputs) and not is_filled:
        if user_inputs[i] == flag:
            #Once flag is found, fill variable.  
            if narg == 1:
                value = assign_value(value,type,user_inputs[i+1]);
            #If value is an array, fill all elements.
            else:
                for j in range(narg):
                    value[j] = assign_value(value,type,user_inputs[i+j+1]);
            is_filled = 1;
        i = i+1;

    #If flag does not exist, set variable to default.
    if not is_filled:
        value = set_default(value,default);
            
    return value;

def check_value_initialized(value,flag,default):

    if value == -9999:
        print 'Error in get_initial_value()'
        print flag + ' could not be found!'
        print 'Try again!'
        sys.exit();
    
            
def set_to_zero(num):
    array = range(num);
    for i in range(num):
        array[i] = 0;
    return array;

def set_dict_option(dict,flag,default):
    try:
        value = dict[flag];
        if len(value) == 1: value=one_dim_arrays_to_variables(value);
    except KeyError:
        value = default;

    return value
            
def set_default(parameter,default):
    if parameter == -9999 or parameter == []:
        parameter = default;
    return parameter;

def open_zipfile(name):
    
    file = -9999;
    
    try:
        file = gzip.open(name).read().splitlines();
    except IOError:
        print name+' could not be found';

    return file;

def open_file(name):
    
    file = -9999;
    
    try:
        file = open(name).read().splitlines();
    except IOError:
        print name+' could not be found';

    return file;

def check_one_dim_options(options,key):
    try:
        return one_dim_arrays_to_variables(options[key])        
    except KeyError:
        sys.exit('Error: '+key+' not specified.  Exiting.');
        
    

