from Numeric import *
import pylab
from matplotlib import cm


#This function makes a pcolor plot and limits axes with the specified options
#Inputs: matrix of contour values (necessary)
#        list of points on the x-axis (optional)
#        list of points on the y-axis (optional)
#Output: a pcolor plot accessible to main()
def _pcolor(matrix,xax=-9999,yax=-9999):

    if xax == -9999 or yax == -9999:
        pic = pylab.pcolor(matrix);
        pylab.xlim(0,len(matrix[0]));
        pylab.ylim(0,len(matrix));
    else:
        pic = pylab.pcolor(xax,yax,matrix);
        pylab.xlim(min(xax),max(xax));
        pylab.ylim(min(yax),max(yax));
    
#Label plot axes and add title
#Inputs:  strings for xlables, ylabels, and titles (all optional)
#Outputs: string printed on the axes of the plot
def _label(xla='',yla='',title=''):

    pylab.xlabel(xla);
    pylab.ylabel(yla);
    pylab.title(title);


#Label successive gridboxes along the x or y axis
#Inputs: list: a list of the labels for the gridboxes
#        xstart: xstarting point
#        ystart: ystarting point
#        step:   stepsize to move along the x- or y- axis
#        dim:    dimension along labels will be can be 'x' or 'y'
#                other dimension will stay constant at xstart or ystart value
#        f:      fontsize of the text.  Defaults to 12.
def gridText(list,xstart,ystart,step,dim,f=12):
    
    for i in xrange(len(list)):
        if dim == 'x':
            pylab.text(xstart+step*i,ystart,str(list[i]),fontsize=f,
                       horizontalalignment='center',
                       verticalalignment='center');
        if dim == 'y':
            pylab.text(xstart,ystart+step*i,str(list[i]),fontsize=f,
                       horizontalalignment='center',
                       verticalalignment='center');


#Turns off ticklabels along the x-axis
def xtickOff():

    pylab.xticks(pylab.arange(1),(''));

#Turns off ticklabels along the y-axis
def ytickOff():

    pylab.yticks(pylab.arange(1),(''));
        
