RESIDUES = ['A', 'U', 'G', 'C', '+A', '+U', '+G', '+C',
            'R', 'Y']

_PURINE_CHI = ('O4*', 'C1*', 'N9', 'C4')
_PYRIMIDINE_CHI = ('O4*', 'C1*', 'N1', 'C2')
CHI_ATOMS = {
    'A': _PURINE_CHI,
    'G': _PURINE_CHI,
    'C': _PYRIMIDINE_CHI,
    'U': _PYRIMIDINE_CHI,
    '+A': _PURINE_CHI,
    '+G': _PURINE_CHI,
    '+U': _PYRIMIDINE_CHI,
    '+C': _PYRIMIDINE_CHI,
    'R': _PURINE_CHI,
    'Y': _PURINE_CHI
    }

SASARAD = {
    'A': {
        'P': 1.9, 'O5*': 1.5, 'C5*': 2.0, 'C4*': 2.0,
        'O4*': 1.5, 'C1*': 2.0, 'C2*': 2.0, 'O2*': 1.5,
        'C3*': 2.0, 'O3*': 1.5, 'N9': 1.5, 'C8': 1.85,
        'N7': 1.7, 'C5': 1.7, 'C6': 1.7, 'N6': 1.8,
        'N1': 1.5, 'C2': 1.7, 'N3': 1.5},
    'G': {
        'P': 1.9, 'O5*': 1.5, 'C5*': 2.0, 'C4*': 2.0,
        'O4*': 1.5, 'C1*': 2.0, 'C2*': 2.0, 'O2*': 1.5,
        'C3*': 2.0, 'O3*': 1.5, 'N9': 1.5,  'C8': 1.85,
        'N7': 1.7, 'C5': 1.7, 'C6': 1.7, 'O6': 1.5,
        'N1': 1.7, 'C2': 1.7, 'N2': 1.85, 'N3': 1.5},
    'U': {
        'P': 1.9, 'O5*': 1.5, 'C5*': 2.0, 'C4*': 2.0,
        'O4*': 1.5, 'C1*': 2.0, 'C2*': 2.0, 'O2*': 1.5,
        'C3*': 2.0, 'O3*': 1.5, 'N1': 1.5, 'C2': 1.7,
        'O2': 1.5, 'N3': 1.7, 'C4': 1.7, 'O4': 1.5,
        'C5': 1.85, 'C6': 1.85},
    'C': {
        'P': 1.9, 'O5*': 1.5, 'C5*': 2.0, 'C4*': 2.0,
        'O4*': 1.5, 'C1*': 2.0, 'C2*': 2.0, 'O2*': 1.5,
        'C3*': 2.0, 'O3*': 1.5, 'N1': 1.5, 'C2': 1.7,
        'O2': 1.5, 'N3': 1.7, 'C4': 1.7, 'N4': 1.85,
        'C5': 1.85, 'C6': 1.85}
    }
SASARAD['+A'] = SASARAD['A']
SASARAD['+G'] = SASARAD['G']
SASARAD['+U'] = SASARAD['U']
SASARAD['+C'] = SASARAD['C']
SASARAD['R'] = SASARAD['A']; SASARAD['R'].update(SASARAD['G'])
SASARAD['Y'] = SASARAD['U']; SASARAD['Y'].update(SASARAD['C'])



